/*
 *  Copyright 2007-2009 NVIDIA Corporation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#pragma once
#pragma warning(disable: 4127)	// conditional expression is constant

//---------------------------------------------------------
// Persistent threads config
//---------------------------------------------------------
#define LOAD_BALANCER
#define LOAD_BALANCER_BATCH_SIZE 3			// (3 for paper)
//#define LOAD_BALANCER_FIRST_WARP 192*32	// G92
//#define LOAD_BALANCER_NUM_WARPS	 192
#define LOAD_BALANCER_FIRST_WARP 720*32		// GT200
#define LOAD_BALANCER_NUM_WARPS	 720

//---------------------------------------------------------
// Misc definitions
//---------------------------------------------------------
#define RAY_BUFFER_SIZE		(3*1048576)	// Maximum batch size
#define RAY_GRID_WIDTH		32			// 
#define RAY_BLOCK_WIDTH		32			// Must be 32 (traversal code assumes RAY_BLOCK_HEIGHT == #warps)
#define RAY_BLOCK_HEIGHT	6			// Block size: 6*32 = 192 threads
#define ENTRYPOINT_SENTINEL 0x76543210

//---------------------------------------------------------
// AOS vs SOA
//---------------------------------------------------------
#define NODES_ARRAY_OF_STRUCTURES
#define TRIANGLES_ARRAY_OF_STRUCTURES

#ifdef NODES_ARRAY_OF_STRUCTURES
	#define N_AOS(x) x
	#define N_SOA(x) 
#else
	#define N_AOS(x) 
	#define N_SOA(x) x
#endif
#ifdef TRIANGLES_ARRAY_OF_STRUCTURES
	#define T_AOS(x) x
	#define T_SOA(x) 
#else
	#define T_AOS(x) 
	#define T_SOA(x) x
#endif

//---------------------------------------------------------
// 
//---------------------------------------------------------
struct RayResult
{
	int   tidx;
	float t;
};

struct RayStruct
{
	float idir_x, idir_y, idir_z;	// 1/ray direction
};
